# Eudyptula Challenge

Le challenge étant fermé, je m'appuie sur les questions trouvables sur des
dépôts Github.

Vous pouvez trouver des réponses (ainsi que des questions)
[sur Github](https://github.com/search?q=Eudyptula).

À noter que j'utilise la commande `indent -linux` pour pouvoir indenter et
formater les fichiers sources selon la convention du kernel Linux.
J'utilise aussi le script `checkpatch.pl -f` pour pouvoir vérifier plus en
profondeur si mes fichiers sources suivent bien la convention (cf. tache 4).

## Compilation

Il vous faut les fichiers d'entetes du kernel Linux (linux-headers sur les
distributions basées Debian).

Il suffit ensuite d'aller dans le dossier de votre choix et faire `make`.

## Ressources

 * [The Linux Kernel Module Programming Guide](https://sysprog21.github.io/lkmpg)

## Réponses

L'Eudyptula challenge demande souvent des preuves de notre réussite. Vous
pouvez retrouver les commandes et leur résultat ici.

### Tache 1

Pour montrer que mon module marche bien, on regarde les logs du kernel avec la
commande `dmesg`.

```
# après insmod hello.ko
[102102.117958] Coucou le gens !!!!
# après rmmod hello
[102108.046104] Tschuss !!!
```

### Tache 2

J'utilise Gentoo et configure puis compile moi-même mon kernel. Je passe cette
étape.

### Tache 3

Patch basé sur la version `v6.2-rc5` du kernel Linux, créé avec la commande
`git format-patch -1 HEAD`.

```
From 6f41b705dbde5b42167c03b8d14ae695b226cb86 Mon Sep 17 00:00:00 2001
From: rick <rick@gnous.eu>
Date: Mon, 23 Jan 2023 16:49:42 +0100
Subject: [PATCH] custom extraversion

---
 Makefile | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/Makefile b/Makefile
index c1ead4cd2342..d67f2f5eb831 100644
--- a/Makefile
+++ b/Makefile
@@ -2,7 +2,7 @@
 VERSION = 6
 PATCHLEVEL = 2
 SUBLEVEL = 0
-EXTRAVERSION = -rc5
+EXTRAVERSION = -eudyptula
 NAME = Hurr durr I'ma ninja sloth
 
 # *DOCUMENTATION*
-- 
2.39.1
```

### Tache 4

Je n'ai pas mit les fichiers corrigés. Il suffit d'utiliser la commande
`indent` pour pouvoir bien indenter le code dans un premier temps. Il faut
ensuite utiliser le script `scripts/checkpatch.pl` sur les fichiers pour
trouver les derniers soucis.
